/*!
  * Licensed Materials - Property of IBM
  * 5725N95, 5725P55, 5725N96
  * (C) Copyright IBM Corp. 1999, 2014.
  * US Government Users Restricted Rights- Use, duplication or disclosure
  * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

 /* $Id: assessment_core.js,v 1.1.2.1 2015/06/30 11:04:37 rakollep Exp $ */
 
AssessmentUI =
{
	currentPage:0,
	init:function()
	{
		AssessmentEngine.questionsPerPage = 1;
		AssessmentEngine.events.timerUpdated.subscribe(AssessmentUI.updateTimer);

		this.page(1);
	},
	page:function(p)
	{
		var yd = YAHOO.util.Dom;
		
		this.currentPage = p;
		AssessmentEngine.currentPage = p;
	
		var elms = yd.getElementsByClassName("page");
		for (var i=0; i<elms.length; i++)
		{
			yd.setStyle(elms[i],"display",((i+1)==p)?"block":"none");
		}
		
		yd.get("progress").innerHTML = "Question "+p+" of "+elms.length;
		jQuery("#prevBtn img").attr("src", (p != 1) ? AssessmentUI.prevBtnImg[0] : AssessmentUI.prevBtnImg[1]);
		jQuery("#nextBtn img").attr("src", (p != elms.length) ? AssessmentUI.nextBtnImg[0] : AssessmentUI.nextBtnImg[1]);
		jQuery("#prevBtn img").attr("alt", (p != 1) ? "Back" : "Back Disabled");
		jQuery("#nextBtn img").attr("alt", (p != elms.length) ? "Next" : "Next Disabled");		
		
		yd.get("content").focus();
	},
	previous:function()
	{
		if ( this.currentPage > 1 )
		{
			this.page(this.currentPage-1);
		}
	},
	next:function()
	{
		var ae = AssessmentEngine;
		
		var pageCount = YAHOO.util.Dom.getElementsByClassName("page").length;

		if ( this.currentPage != pageCount )
		{
			if ((!ae.assessment.allowSkipQuestions && !ae.assessment.allowBackwardsNavigation) && !ae.isPageCompleted(this.currentPage))
			{
				// not allowed to navigate backwards and not allowed to skip and the page has unanswered questions
				alert(ae.skippedNotAllowedMsg);
			}
			else
			{
				this.page(this.currentPage+1);
			}
		}
	},
	updateTimer : function()
	{
		if (AssessmentEngine.remaining > 0)
		{
			YAHOO.util.Dom.get("timer").innerHTML = "Time Remaining: "+AssessmentUI.formatDisplayTime(AssessmentEngine.remaining);
		}
	},
	formatDisplayTime : function(r) 
	{
		var h = 0;
		var m = 0;
		var s = 0;
		
		if ( r < 60 ) 
		{
			s = r;
		}
		else if ( r < 3600 ) 
		{
			m = Math.floor(r / 60);
			s = (r - (m * 60));
		}
		else {
			h = Math.floor( r / 3600 );
			m = Math.floor(( r - (h * 3600)) / 60 );
			s = (r - ( h * 3600 ) - ( m * 60 ));
		}
		
		if (m < 10) m = "0"+m;
		if (s < 10) s = "0"+s;
		
		return h+":"+m+":"+s;
	}
}
YAHOO.util.Event.addListener(window,"load",AssessmentUI.init,AssessmentUI,true);